UsePNGImageDecoder()

Structure p3d
  x.f
  y.f
  z.f
EndStructure
Dim cube.p3d(8)
Dim cube2.p3d(8)
ed=100
;         // face vertices
Dim face.b(24)
;(0,3,1,2, 0,5,4,1, 0,6,2,4, 6,3,2,7, 3,5,1,7, 4,7,6,5);
face(1)=0
face(2)=1
face(3)=3
face(4)=2

face(5)=1
face(6)=5
face(7)=7
face(8)=3

face(9)=4
face(10)=6
face(11)=7
face(12)=5

face(13)=0
face(14)=2
face(15)=6
face(16)=4

face(17)=0
face(18)=4
face(19)=5
face(20)=1

face(21)=2
face(22)=3
face(23)=7
face(24)=6


;(-1,-1,-1;;1
;, -1,-1,1,;;2
;-1,1,-1,;;3
;-1,1,1, ;;4
;1,-1,-1, ;;5
;1,-1,1;;6
;1,1,-1,;;7
;1,1,1);;8
cube(1)\x=-ed
cube(1)\y=-ed
cube(1)\z=-ed

cube(2)\x=ed
cube(2)\y=-ed
cube(2)\z=-ed

cube(3)\x=-ed
cube(3)\y=ed
cube(3)\z=-ed

cube(4)\x=ed
cube(4)\y=ed
cube(4)\z=-ed

cube(5)\x=-ed
cube(5)\y=-ed
cube(5)\z=ed

cube(6)\x=ed
cube(6)\y=-ed
cube(6)\z=ed

cube(7)\x=-ed
cube(7)\y=ed
cube(7)\z=ed

cube(8)\x=ed
cube(8)\y=ed
cube(8)\z=ed

xyrot.f =0
xzrot.f = 0
yzrot.f = 0


If InitSprite() And OpenWindow(0,0,0,800,600,"JelloCube",#PB_Window_SystemMenu) And OpenWindowedScreen(WindowID(0),0,0,800,600,0,0,0)
  
 CatchImage(18,?girlhand)
  sn.a=0
  sj.a=0
  st.a=0
For i=0 To 15+1
  CreateImage(i,320,360)
Next i

For i=1 To 24
  face (i)=face(i)+1
Next i

  Repeat 
    ;---------------rotate cube-----------------
    xyrot =xrot+1;0.02 / 2;
    xzrot = xzrot+2;0.04 / 2;
    yzrot = yzrot+3;0.03 / 2;
    
    If xyrot>=360:xyrot=0:EndIf
    If xzrot>=360:xzrot=0:EndIf
    If yzrot>=360:yzrot=0:EndIf
    
    StartDrawing(ImageOutput(sn))
    Box(0,0,320,360,0);Box(0,0,640,480,0)
    For i=1 To 8
;        // xy rot
        x = cube(i)\x
        y = cube(i)\y
        z = cube(i)\z
        cube2(i)\x=x*Cos(Radian(xyrot))-y*Sin(Radian(xyrot))
        cube2(i)\y=y*Cos(Radian(xyrot))+x*Sin(Radian(xyrot))
        cube2(i)\z=z
        
;        // xzrot
        x=cube2(i)\x
        y=cube2(i)\y
        z=cube2(i)\z

        cube2(i)\x=x*Cos(Radian(xzrot))-z*Sin(Radian(xzrot))
        cube2(i)\y=y
        cube2(i)\z=z*Cos(Radian(xzrot))+x*Sin(Radian(xzrot))

;        // yzrot
        x=cube2(i)\x
        y=cube2(i)\y
        z=cube2(i)\z

        cube2(i)\x=x
        cube2(i)\y=y*Cos(Radian(yzrot))+z*Sin(Radian(yzrot))
        cube2(i)\z=z*Cos(Radian(yzrot))-y*Sin(Radian(yzrot))
        
;        // perspective
        x=cube2(i)\x
        y=cube2(i)\y
        z=cube2(i)\z
        cube2(i)\x = (x * 800) / (800 - z)
        cube2(i)\y = (y * 800) / (800 - z)
        cube2(i)\z=z
        
        
      Next i
      
      x0=320/2
      y0=240-60
  ;    Box(0,0,320,360,RGB(0,0,255))
  For i=1 To 23 Step 4
    x1=cube2(face(i))\x+x0
    y1=cube2(face(i))\y+y0
    
    x2=cube2(face(i+1))\x+x0
    y2=cube2(face(i+1))\y+y0
    
    x3=cube2(face(i+2))\x+x0
    y3=cube2(face(i+2))\y+y0
    
    x4=cube2(face(i+3))\x+x0
    y4=cube2(face(i+3))\y+y0
    
    If (x2-x1)*(y1-y3)-(x1-x3)*(y2-y1)>0
     LineXY(x1,y1,x2,y2,RGB(255,0,0))
     LineXY(x1,y1,x4,y4,RGB(255,0,0))
     LineXY(x2,y2,x3,y3,RGB(255,0,0))
     LineXY(x3,y3,x4,y4,RGB(255,0,0))
    EndIf

  Next i
  StopDrawing()
  sj=(sj+1)&15
  st=sj
  StartDrawing(ImageOutput(16))
  For i=0 To 15
    GrabImage(st&15,17,0,24*i,320,24)
    st+1
    DrawImage(ImageID(17),0,24*i)
  Next i
  StopDrawing()

  StartDrawing(ScreenOutput())
  DrawImage(ImageID(18),0,0)
  
  DrawingMode(#PB_2DDrawing_XOr)
  DrawImage(ImageID(16),160*2,180)
  DrawingMode(#PB_2DDrawing_Default)
  
;  DrawAlphaImage(ImageID(18),0,0)

  sn=(sn+1)&15
  StopDrawing()
  FlipBuffers() 
  Until WindowEvent()=#PB_Event_CloseWindow 
EndIf

DataSection
girlhand:
  IncludeBinary "suninhand.png"
EndDataSection
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 192
; FirstLine = 157
; Executable = jellocube.exe